Subject: FVWM: my wish list

From: [email-masked] (Scott RoLanD)
Date: Sat, 23 Sep 1995 17:08:38 -0700 (PDT)

NOte, I am willing to believe that the following might show my
cluelessness. I am currently using fvwm 1.24r. If there is someway to
accomplish the following, even with just an upgrade to the beta 2.0,
please let me know.

***Control over the icon pixmap vs. the 'icon text' the floats under
the icon pixmap (or is the sole piece of the icon when there is no
pixmap):
	I'm really picky on space, and for programs like cm the icon
pixmap is sufficient and I don't want the icon text to even
appear. For most other things, I don't want there to be any icon
pixmap, just the icon text (trying to give a small 'invisible' pixmap,
just results in the icon text being as small in width as the pixmap).

***Ability to make a key equivalent to a certain mouse click:
	I've got in the habit of using the keyboard to move my mouse
pointer around, but in some cases, this is useless unless I can click.

***Ability to use a double-click when the second click is held down:
	I currently use the following setup, which allows me to click
and release to get a menu, as well as click and hold to get a menu,
but I can't double-click and hold to get the other menu.

Popup "Mouse1Popups"
	Popup		"Click"			FVWM_control
	Popup		"Motion"		FVWM_control
	Popup		"DoubleClick"		screen_locks	
EndFunction

***Better control of moving and resizing from commands:
	What I mean here are things I can link to the click of a
button, like Maximize. But I hate the way maximize set the position to
0 0. Is there any way give a window a size or position?

***Ability to change the button pixmaps
	I have a feeling I just don't know what to do on this.

***Ability to set the pointer inner and outer color.
	Am I missing something?

***Have a StartsOnPage like StartsOnDesk

***Question, why do commands like iconify and delete not wait for a
window if you set them to a mouse-click in the root window? I
currently use the following, which works, but I was just curious:

Function "Iconify"
	Iconify		"Click"
EndFunction

Mouse 0		AT142	MS	Function "Iconify"

That's all I can remember---
shr
--
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: <[email-masked]> (Charles Hines)
Date: Mon, 25 Sep 1995 14:12:11 -0400

>>>>> "Scott" == Scott RoLanD <[email-masked]> writes:

Scott> NOte, I am willing to believe that the following might show my
Scott> cluelessness. I am currently using fvwm 1.24r. If there is
Scott> someway to accomplish the following, even with just an upgrade
Scott> to the beta 2.0, please let me know.

The beta 2.0 is just about ready to be officially released, and a lot
of these things behave better or are easier to implement under it, so
you might want to upgrade.  BTW - The official (non beta) 2.0 should
be ready within the next few weeks.

Scott> ***Control over the icon pixmap vs. the 'icon text' the floats under
Scott> the icon pixmap (or is the sole piece of the icon when there is no
Scott> pixmap):
Scott>  I'm really picky on space, and for programs like cm the icon
Scott> pixmap is sufficient and I don't want the icon text to even
Scott> appear. For most other things, I don't want there to be any icon
Scott> pixmap, just the icon text (trying to give a small 'invisible' pixmap,
Scott> just results in the icon text being as small in width as the pixmap).

Check out the man page where it describes the 'Style' command,
specifically the 'NoIconTitle' and the 'Icon/NoIcon' parts.

Scott> ***Ability to make a key equivalent to a certain mouse click:
Scott>  I've got in the habit of using the keyboard to move my mouse
Scott> pointer around, but in some cases, this is useless unless I can click.

Hhhmmm.... I don't think that there is any way to do this currently in
either 1.xx or 2.xx.  Since the cursor can be moved from keystrokes
through fvwm, it seems to hold that you should be able to simulate a
button press as well...  I'll look into how hard it would be to add
this feature to 2.xx.

Scott> ***Ability to use a double-click when the second click is held down:
Scott>  I currently use the following setup, which allows me to click
Scott> and release to get a menu, as well as click and hold to get a menu,
Scott> but I can't double-click and hold to get the other menu.

Scott> Popup "Mouse1Popups"
Scott>  Popup           "Click"                 FVWM_control
Scott>  Popup           "Motion"                FVWM_control
Scott>  Popup           "DoubleClick"           screen_locks
Scott> EndFunction

I think that something like this will work in 2.xx, but I've never
tried it...  Nope - a quick test shows that it doesn't work there
either.  I'll take a look and see if this is a bug or working as
designed and how easily fixed/implemented.

Scott> ***Better control of moving and resizing from commands:
Scott>  What I mean here are things I can link to the click of a
Scott> button, like Maximize. But I hate the way maximize set the position to
Scott> 0 0. Is there any way give a window a size or position?

This can be done in 2.xx easier, I believe.

Scott> ***Ability to change the button pixmaps
Scott>  I have a feeling I just don't know what to do on this.

You mean title bar buttons?  They can be redesigned via the
ButtonStyle command, but you can't specify arbitrary bitmaps or
pixmaps (yet).  This might be added later.

Scott> ***Ability to set the pointer inner and outer color.
Scott>  Am I missing something?

I don't think that this can be specified, currently.

Scott> ***Have a StartsOnPage like StartsOnDesk

Just use the geometry specs to do this -> just add multiples of the
screen width & height.  It's the only way to do it right now.

Scott> ***Question, why do commands like iconify and delete not wait for a
Scott> window if you set them to a mouse-click in the root window? I
Scott> currently use the following, which works, but I was just curious:

Scott> Function "Iconify"
Scott>  Iconify         "Click"
Scott> EndFunction

Scott> Mouse 0          AT142   MS      Function "Iconify"

In 2.xx, Just 'Mouse 1 R N Iconify' more or less works by iconifying
the window that you RELEASE over.  I think it behaved the same in
1.xx, but I'm not sure.

Scott> That's all I can remember---

Hope I've been of assistance.

Chuck

*******************************************************************************
Charles K. Hines
IBM Logic Synthesis developer [BooleDozer (TM)]
and Martial Arts Instructor [Modern Arnis, Presas Style Filipino Martial Arts]

Internet e-mail:     [email-masked]

IBM Internal e-mail: [email-masked]   (preferred from workstation)
                     HINESC at FISHKILL       (preferred from mainframe)
                     HINESC at FSHVMFK1       (discouraged, but I'll get it)

*******************************************************************************
 "dis ting could have possabiwities if I put my twisted widdle mind to it!"
                                                        - Bugs Bunny

 "I have a paper plate in my head because they were all out of the metal ones"
                                                        - Rick Overton
*******************************************************************************
--
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: BENJAMIN THOMAS KETTERIDGE <[email-masked]>
Date: Tue, 26 Sep 1995 10:28:03 +0100

>button press as well...  I'll look into how hard it would be to add
I discussed this in great detail with Rob, maybe a year or two back, and we
decided that it's not really feasible, for a number of reasons:

a) which window gets the click?
b) many programs ignore simulated events - which a key-press mouse binding
   would produce.
c) it's too complicated (or that's the impression I got) ;-)

Having said that, if you, Chuck, can find a way, I would be _very_ interested
in seeing it in 2.xx!! (I move the mouse pointer by key-presses alot too!)

Tara,
Ben.

| URL=http://www.dcs.aber.ac.uk/~btk/ | email=[email-masked] | _|--|_   o   |
+-------------------------------------+----------------------+  (\/)  +---+ |
|  Tel: (01970) 622403 [Int: 2403]    |  or: (01970) 627842  |   vv    / \  |
--
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: [email-masked]
Date: Tue, 26 Sep 1995 10:26:43 +0100 (MET)

> Scott> to the beta 2.0, please let me know.

 I have a similar question. I read that in the X-window FAQ :

------------------------------------------------------------------------------
Subject:  20)  How do I remap the keys on my keyboard to produce a string?

	There is no method of arranging for a particular string to be produced
when you press a particular key. The xmodmap client, which is useful for
moving your CTRL and ESC keys to useful places, just rearranges keys and does
not do "macro expansion."
[deleted text]
	Window managers, which could provide this facility, do not yet; nor
has a special "remapper" client been made available.
------------------------------------------------------------------------------

does fvwm 2.0 does it ? 

Pascal

---

From: Jim Clark <[email-masked]>
Date: Wed, 27 Sep 1995 07:34:15 +1000 (EST)

>  I have a similar question. I read that in the X-window FAQ :

You can however map keys to strings within an xterm by setting up keymap
translations in your Xresource (or Xdefaults) file (handy for function key
shortcuts).
>From the Xterm manpage;

     Below is a sample how of the keymap() action is used to  add
     special keys for entering commonly-typed works:

         *VT100.Translations: #override <Key>F13: keymap(dbx)
         *VT100.dbxKeymap.translations: \
              <Key>F14: keymap(None) \n\
              <Key>F17: string("next") string(0x0d) \n\
              <Key>F18: string("step") string(0x0d) \n\
              <Key>F19: string("continue") string(0x0d) \n\
              <Key>F20: string("print ") insert-selection(PRIMARY, CUT_BUFFER0)

Jim
-- 
       .    +-----------------------------------------------------------------+
   ,--_|\   | Jim Clark - Consultant for Real Time Australia, Pty. Ltd.       |
  /  Oz  \  |           - at Telecom's  Intelligent Network Development       |
  \_,--\_/  | 'what we see is what we get; nothing else is real' - Niels Bohr |
        v   +-----------------------------------------------------------------+

---

From: [email-masked] (Scott RoLanD)
Date: Tue, 26 Sep 1995 16:58:02 -0700 (PDT)

> specifically the 'NoIconTitle' and the 'Icon/NoIcon' parts.
Cool, that covers half of what I want, but I think I want a new set of
styles 'IconPixmap/NoIconPixmap' so that I can choose to just show the
Icon Title w/o any attached pixmap:
	Style "*"	IconTitle, NoIconPixmap

> designed and how easily fixed/implemented.

You got my confidence up enough to look at my 1.24r code; and I got it
to work they way I want with this patch:
__________________________________cut-here
1422,1427c1422,1427
<   if((HaveDoubleClick) && (type == ONE_AND_A_HALF_CLICKS) &&
<      (IsClick(x,y,ButtonReleaseMask, &d)))
<     {
<       type = DOUBLE_CLICK;
<       ev = &d;
<     }
---
>   if((HaveDoubleClick) && (type == ONE_AND_A_HALF_CLICKS))
>     { 
>       IsClick(x,y,ButtonReleaseMask, &d);
>       type = DOUBLE_CLICK; 
>       ev = &d; 
>     } 
__________________________________cut-here

Without the IsClick(...) line, it is faster than the release of the
second-click, a sleep could be used, but I think that using IsClick
might also do some nice handling of quick movement after a
double-click (with a hold on the second click)----

I'm not sure if it was intentionally coded the other way before, but
it appeared to drop the case where I double click with a hold on the
second click.....

> Hope I've been of assistance.

Very much so, I recommend you get a raise!!!

Another satisfied FVWM customer,
shr

PS If your curious, I'm not jumping to 2.0 beta now since you keep
saying that the official 2.0 will be put out soon (not that I'm afraid
of beta's, I just don't want to make two updates in two weeks). Just
don't announce that you've decided it will be FVWM '96. ;-)
--
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: <[email-masked]> (Charles Hines)
Date: Wed, 27 Sep 1995 10:13:16 -0400

>> specifically the 'NoIconTitle' and the 'Icon/NoIcon' parts.
Scott> Cool, that covers half of what I want, but I think I want a new set of
Scott> styles 'IconPixmap/NoIconPixmap' so that I can choose to just show the
Scott> Icon Title w/o any attached pixmap:
Scott>  Style "*"       IconTitle, NoIconPixmap

Actually, if you just don't specify an Icon, and it (the app) doesn't
have a built in one, then it should only come up w/ the title.  But
perhaps another style option that inhibits even built in icons (as you
suggest) would be a good idea.  It'll have to wait until the Style
flags overhaul though, which will be my first big change after the
first official release.

>> designed and how easily fixed/implemented.

Scott> You got my confidence up enough to look at my 1.24r code; and I got it
Scott> to work they way I want with this patch:
....
Scott> Without the IsClick(...) line, it is faster than the release of the
Scott> second-click, a sleep could be used, but I think that using IsClick
Scott> might also do some nice handling of quick movement after a
Scott> double-click (with a hold on the second click)----

Scott> I'm not sure if it was intentionally coded the other way before, but
Scott> it appeared to drop the case where I double click with a hold on the
Scott> second click.....

Well, I'll check out that patch and see if it adversely effects
anything else.  It does change the behavior to happen on the press
instead of the release though, which was talked about a long time ago.
I believe MWM does a lot on the press as well.

>> Hope I've been of assistance.

Scott> Very much so, I recommend you get a raise!!!

Thanks.  Unfortunately FVWM isn't part of my job description.  It's
just something to do in the little spare time that I have left...  I
do deservie a raise for the other stuff I do, though! ;^)

Scott> Another satisfied FVWM customer,
Scott> shr

Scott> PS If your curious, I'm not jumping to 2.0 beta now since you keep
Scott> saying that the official 2.0 will be put out soon (not that I'm afraid
Scott> of beta's, I just don't want to make two updates in two weeks). Just
Scott> don't announce that you've decided it will be FVWM '96. ;-)

Don't worry.  Just a little while longer...

Chuck

---

From: <[email-masked]> (Charles Hines)
Date: Wed, 27 Sep 1995 10:20:18 -0400

>>>>> "Ben" == BENJAMIN THOMAS KETTERIDGE <[email-masked]> writes:

Ben> In message <[email-masked]>
>> button press as well...  I'll look into how hard it would be to add

Ben> I discussed this in great detail with Rob, maybe a year or two
Ben> back, and we decided that it's not really feasible, for a number
Ben> of reasons:

Ben> a) which window gets the click?

Presumably, the one "on top" under the cursor hot spot.  But how to
determine that easily - that's probably the problem.

Ben> b) many programs ignore simulated events - which a key-press
Ben>    mouse binding would produce.

Right.  That might be a problem.

Ben> c) it's too complicated (or that's the impression I got) ;-)

I believe that.

Ben> Having said that, if you, Chuck, can find a way, I would be
Ben> _very_ interested in seeing it in 2.xx!! (I move the mouse
Ben> pointer by key-presses alot too!)

Well, I'll look into it.  I can't guarantee anything, obviously.

Chuck

---

From: [email-masked]
Date: Thu, 28 Sep 1995 08:10:44 +0100 (MET)

> translations in your Xresource (or Xdefaults) file (handy for function key

I know it and I use it. But I want that sort of things to work with
all X-clients. I like to have Ctrl-left to generate Esc-b which do in
genral backward-word function.

For xterm, I use translation but I want to do it with more clients.

I think it would be a good thing to have at least two level :

  - application preferences with translations as I do with xterm

  - global preferences at window manager level

thanks for your answer.

Pascal

ps : do you know where I can have some informations about
     translations. I do some things with the exemple in the xterm man
     page but I wasn't able to find a complete explanation of the
     syntax of translations.